from Device import *


class RAM(Device):
    def __init__(self, addr_range, addr_bus_width):
        Device.__init__(self, addr_range, addr_bus_width)

    def reset(self, init_val=0xAA):
        self.mem = bytearray(chr(init_val) * (2**self.addr_bus_width), encoding='iso-8859-1')

    def read(self, addr):
        offset = addr-self.addr_range[0]
        offset &= 2**self.addr_bus_width-1
        return self.mem[offset]

    def write(self, addr, val):
        offset = addr-self.addr_range[0]
        offset &= 2**self.addr_bus_width-1
        self.mem[offset] = val
