from Device import *


class ROM(Device):
    def __init__(self, fname, addr_range, addr_bus_width):
        Device.__init__(self, addr_range, addr_bus_width)
        self.fname = fname

    def reset(self):
        with open(self.fname, 'rb') as fileh:
            self.mem = bytearray(fileh.read(2**self.addr_bus_width))

    def read(self, addr):
        offset = addr-self.addr_range[0]
        offset &= 2**self.addr_bus_width-1
        return self.mem[offset]

    def write(self, addr, val):
        raise ReadOnlyMemory(addr)
